console = {h = (love.graphics.getHeight() / 4) * 3}

box_text = ""

console_text = "Game Loaded"
console_visible = false
console_lastcmd = ""
console_font = love.graphics.newFont(14)

key_toggle = "f2"

bc = {r = 0, g = 0, b = 0, a = 130}--Background color
btc = {r = 255, g = 255, b = 255, a = 255}--Box text color
ctc = {r = 255, g = 255, b = 255, a = 180}--Box text color

function console:draw(dt)
	love.graphics.setFont(console_font)
	if console_visible then
		love.graphics.setColor(bc.r, bc.g, bc.b, bc.a)
		love.graphics.rectangle("fill", 0, console.h, love.graphics.getWidth(), console.h)
		love.graphics.setColor(btc.r, btc.g, btc.b, btc.a)
		love.graphics.print(box_text, 4, love.graphics.getHeight() - 16)
		love.graphics.setColor(ctc.r, ctc.g, ctc.b, ctc.a)
		love.graphics.print(console_text, 4, console.h+4)
	end
end

function console:keypressed(key, unicode)
	if key == key_toggle then
		console_visible = not console_visible
	end

	if console_visible then
		if unicode > 31 and unicode < 127 then
	   box_text = box_text .. string.char(unicode)
	  end
	  if key == "backspace" then
			box_text = string.sub(box_text, 0, -2)
		elseif key == "return" then
			if string.len(box_text) > 0 then
				console:runCommand(split(box_text))
				console_lastcmd = box_text
				box_text = ""
			end
		end
	end
end

function console:msg(t)
	console_text = t.."\n"..console_text
end

function console:runCommand(t)
	local s = ""
	for i=1, #t do s = s..t[i].." " end
	s = string.sub(s, 0, -2)
	
	if t[1] == "exit" or t[1] == "quit" then
		love.event.push("quit")
	elseif t[1] == "say" then
		if t[2] == nil then
			console:msg("Usage: say <msg>")
		else
			local msg = ""
			for i=2, #t do msg = msg..t[i].." " end
			console:msg(msg)
		end
	elseif t[1] == "snake" then
		if t[2] == nil then
			console:msg("Usage: snake <setspeed/tp>")
		elseif t[2] == "setspeed" then
			if t[3] == nil then
				console:msg("Usage: snake setspeed <speed>")
			else
				if tonumber(t[3]) then
					snake.s = tonumber(t[3])
					console:msg("Speed set to "..t[3])
				else
					console:msg("Speed must be a number.")
				end
			end
		end
	else
		console:msg("Command '"..s.."' not recognized.")
	end
end

function split(str)
   local t = {}
			str:gsub("([^ ]+)", function(c) t[#t+1] = c end)
   return t
end