game = {}

--snake
snake = {
	x = math.floor((love.graphics.getWidth() / scale) / 2),
	y = math.floor((love.graphics.getHeight() / scale) / 2),
	s = 0.05,
	d = "right",
	tick = 0,
	l = 100
}
tail = {}

--Game 
gameover = false
game_paused = false
score = 0

turned = false

wait = 0.5
wtick = 0

pickups = {}

p = {
	i = 2, --Spawn interval
	tick = 0
}

--==[ TILE SYSTEM ]==--
tiles = {}

function addTile(x, y, t)
	tiles[#tiles + 1] = {
		x = x,
		y = y,
		t = t, --Type
		c = false, --Close to player
		col = false
	}
end

function readmap(map)
	for i=#tiles, 1, -1 do
		table.remove(tiles, i)
	end
	for y=0, map:getHeight()-1 do
		for x=0, map:getWidth()-1 do
			r, g, b, a = map:getPixel(x, y)
			if r == 255 and g == 0 and b == 0 and a == 255 then
				addTile(x, y, 0)
			elseif r == 255 and g == 255 and b == 255 and a == 255 then
				pickups[#pickups + 1] = {x = x, y = y, del = false}
			end
		end
	end	
end

function resetSnake()
	for i=1, #tail do
		tail[i] = nil
	end
	snake.x = math.floor((love.graphics.getWidth() / scale) / 2)
	snake.y = math.floor((love.graphics.getHeight() / scale) / 2)
	snake.d = "right"
	snake.tick = 0
	snake.l = 5
	readmap(map[curMap])
end

function updateTail()
	local x = snake.x
	local y = snake.y
	
	if snake.d == "right" then
		x = x - 1
	elseif snake.d == "left" then
		x = x + 1
	elseif snake.d == "up" then
		y = y + 1
	elseif snake.d == "down" then
		y = y - 1
	end
	
	
	tail[#tail + 1] = {x = x, y = y, a = 255}
	if #tail > snake.l then
			table.remove(tail, 1)
	end
end
--[[
if snake.x > love.graphics.getWidth() / scale - 1 then
	snake.x = 0
elseif snake.x < 0 then
	snake.x = love.graphics.getWidth() / scale - 1
end
if snake.y > love.graphics.getHeight() / scale - 1 then
	snake.y = 0
elseif snake.y < 0 then
	snake.y = love.graphics.getHeight() / scale - 1
end
--]]
function moveSnake()
		if snake.d == "left" then
			if (snake.x) < 0 then
				snake.x = love.graphics.getWidth() / scale - 1
			else
				snake.x = snake.x - 1
			end
		elseif snake.d == "right" then
			if (snake.x + 1) > love.graphics.getWidth() / scale then
				snake.x = 0
			else
				snake.x = snake.x + 1
			end
		elseif snake.d == "up" then
			if snake.y < 0 then
				snake.y = love.graphics.getHeight() / scale - 1
			else
				snake.y = snake.y - 1
			end
		elseif snake.d == "down" then
			if (snake.y + 1) > love.graphics.getHeight() / scale then
				snake.y = 0
			else
				snake.y = snake.y + 1
			end
		end
		updateTail()
		--Pickups
		for i=1, #pickups do
			if snake.x == pickups[i].x and snake.y == pickups[i].y then
				--][ PICKING UP SHIT [[--
				pickups[i].del = true
				snake.l = snake.l + 1
				score = score + 1
			end
		end
end

function checkNext() -- Checks snakes next position
	local safe = true

	local nx = snake.x
	local ny = snake.y
	--Finding new coords
	if snake.d == "left" then
		nx = nx - 1
	elseif snake.d == "right" then
		nx = nx + 1
	elseif snake.d == "down" then
		ny = ny + 1
	elseif snake.d == "up" then
		ny = ny - 1
	end
	
	--Tile check
	for i=1, #tiles do
		if tiles[i].x == nx and tiles[i].y == ny then
			safe = false
		end
	end
	
	--Tail check
	for t=1, #tail do
		if tail[t].x == nx and tail[t].y == ny then
			safe = false
		end
	end
	
	return safe
end

function game.update(dt)
	if not gameover then
		--==[ SNAKE UPDATE ] ==--
		snake.tick = snake.tick + dt
		if snake.tick > snake.s then
			if not game_paused and not console_visible then
				if not checkNext() then
					game.ended("lost")
				else
					moveSnake()
					for i=#pickups, 1, -1 do
						if pickups[i].del then
							table.remove(pickups, i)
						end
					end
					
					--game update
					if #pickups <= 0 then
						game.ended("won")
					end
					
					turned = false
					snake.tick = 0
				end
			end
		end
		
	else
		wtick = wtick + dt
		if wtick > wait then
			resetSnake()
		--	for i=1, #pickups do
			--	pickups[i] = nil
			--end
			score = 0
			gameover = false
			wtick = 0
		end
	end
	
end

function game.draw()
	love.graphics.setColor(255, 255, 255, 255)
	--love.graphics.setBlendMode("alpha")
	love.graphics.draw(bg)
	--==[ WORLD ]==--
	for i=1, #tiles do
		love.graphics.setColor(0, 0, 0, 200)
		love.graphics.rectangle("fill", tiles[i].x * scale, tiles[i].y * scale, scale, scale)
	end
	love.graphics.setBlendMode("additive")
	--==[ SNAKE ]==--
	--love.graphics.setBlendMode("additive")
	love.graphics.setColor(138, 255, 0, 255)
	love.graphics.rectangle("fill", snake.x * scale , snake.y * scale, scale, scale)
	for i=1, #tail do
		local a = 255
			a = a / #tail * i 
			if a < 50 then a = 50 end
		love.graphics.setColor(138, 255, 0, a)
		love.graphics.rectangle("fill", tail[i].x * scale, tail[i].y * scale, scale, scale)
	end
	--==[ PICKUPS ]==--
	love.graphics.setBlendMode("alpha")
	love.graphics.setColor(255, 255, 255, 255)
	for r=1, #pickups do
		love.graphics.draw(blip, pickups[r].x * scale, pickups[r].y * scale)
	end
	--==[ HUD ]==--
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(grid)
	--love.graphics.print("Score: "..score, 4 , 4)
	--love.graphics.print("Score: "..score, 12, 12)
	if game_paused then
		love.graphics.setColor(0, 0, 0, 100)
		love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
		love.graphics.setColor(138, 255, 0, 255)
		love.graphics.setFont(f)
		love.graphics.print("Paused", love.graphics.getWidth()/2 - 130, 100)
	end
end

function game.keypressed(key, unicode)
	if key == "left" then
		if snake.d == "up" or snake.d == "down" then
			if not turned then
				snake.d = "left"
				turned = true
			end
		end
	elseif key == "right" then
		if snake.d == "up" or snake.d == "down" then
			if not turned then
				snake.d = "right"
				turned = true
			end
		end
	elseif key == "up" then
		if snake.d == "left" or snake.d == "right" then
			if not turned then
				snake.d = "up"
				turned = true
			end
		end
	elseif key == "down" then
		if snake.d == "left" or snake.d == "right" then
			if not turned then
				snake.d = "down"
				turned = true
			end
		end
	elseif key == "escape" then
		game_paused = not game_paused
		local s = love.mouse.isVisible()
		s = not s
		love.mouse.setVisible(s)
	end
end


--==[ GAME FUNCTIONS ] ==--

function game.ended(r)
	if r == "lost" then
		gameover = true
	elseif r == "won" then
		gameover = true
		if curMap + 1 <= mc then
			curMap = curMap + 1
		else
			curMap = 1
		end
	end
end